// Definicije metoda uz klasu Zbirka.

#include "zbirka.h"

void Zbirka::kopiraj (const Zbirka &zz) {         // Kopiranje liste.
  prvi = posl = 0; duz = zz.duz;
  for (Elem *tek=zz.prvi; tek; tek=tek->sled) {
    Elem *novi = new Elem (tek->fig->kopija ()); if (! novi) exit (1);
    if (! prvi) prvi = novi; else posl->sled = novi;
    posl = novi;
  }
}

void Zbirka::brisi () {                           // Brisanje liste.
  while (prvi) { Elem *stari = prvi; prvi = prvi->sled; delete stari; }
  posl = 0; duz = 0;
}

Figura & Zbirka::operator[] (int ii) const {      // Odabrana figura.
  if (ii<=0 || ii>duz) exit (2);
  for (Elem *tek=prvi; ii>1; tek=tek->sled, ii--);
  return *tek->fig;
}

ostream &operator<< (ostream &dd, const Zbirka &zz){ // Pisanje zbirke.
  dd << zz.vrsta() << "{\n";
  for (Zbirka::Elem *tek=zz.prvi; tek; tek=tek->sled)
    dd << "  " << *tek->fig << endl;
  return dd << "}\n";
}
