// Definicija apstraktne klase zbirki figura (Zbirka).

#ifndef _zbirka_h_
#define _zbirka_h_

#include "figura.h"
#include <iostream.h>
#include <stdlib.h>

class Zbirka {
protected:
  struct Elem {                           // Elementi liste:
    Figura *fig;                          //   sadraj elementa,
    Elem *sled;                           //   sledeci element,
    Elem (const Figura *ff, Elem *ss=0)   //   stvaranje elementa,
      { fig = (Figura *)ff; sled = ss; }
    ~Elem () { delete fig; }              //   unitavanje elementa.
  };
  Elem *prvi, *posl;                      // Pocetak i kraj liste.
  int duz;                                // Duina liste.
  void kopiraj (const Zbirka &) ;         // Kopiranje liste.
  void brisi () ;                         // Brisanje liste.
public:
  Zbirka() { prvi = posl = 0; duz = 0; }  // Stavaranje prazne zbirke.
  Zbirka (const Figura &ff)               // Konverzija figure u zbirku.
    { if ((prvi = posl = new Elem (&ff)) == 0) exit (1); }
  Zbirka (const Zbirka &zz)               // Konstruktor kopije.
    { kopiraj (zz); }
  virtual ~Zbirka () { brisi (); }        // Unitavanje zbirke.
  virtual Zbirka & operator=(const Zirka &zz){ // Dodela vrednosti.
    if (this != &zz) { brisi (); kopiraj (zz); }
    return *this;
  }
  int operator+ () const { return duz; }      // Broj elemenata zbirke.
  virtual Zbirka & operator+= (const Figura &) =0; // Dodavanje figure.
  virtual Figura & operator-- () =0 ;         // Uzimanje tekuce figure.
  virtual Figura & operator-  () const =0 ;   // Tekuca figura.
  Figura & operator[] (int) const ;           // Odabrana figura.
  friend ostream & operator<<                 // Pisanje zbirke.
    (ostream &, const Zbirka &) ;
  Zbirka & operator~ ()                       // Pranjenje zbirke.
    { brisi (); return *this; }
  virtual const char *vrsta () const =0 ;     // Vrsta zbirke.
  virtual Zbirka *kopija () const =0 ;        // Kopija zbirke.
} ;

#endif;
